
function [links,nolinks,linkscontrol,nolinkscontrol] = CObyCOR(corrtype,Cv,J)
% Finding strong and weak edges offered by correlation as additional
% constraints.

switch corrtype
    case 'PC'
        HighCorrlim = 0.95;
        LowCorrlim  = 0.01;
        R = corrcov(Cv);
    case 'GGM'
        HighCorrlim = 0.6;
        LowCorrlim  = 0.001;
        P = corrcov(Cv);
        B = inv(P);
        v = diag(B);
        R = (-1*B)./(sqrt(v*v'));
end

tempo = abs(R);

dummy = (HighCorrlim+LowCorrlim)/2;
I = tril(ones(size(tempo)),0);
tempo(find(I))=dummy;
V1 = tempo(:);
% V1 = absR(find(I));  % V1: The vector of upper triangular elements of absR


% I = triu(ones(size(J)),1);
% V2 = J(find(I));    % V2: The vector of upper triangular elements of Jacobian
V2 = J(:);

links = find(V1 > HighCorrlim);
nolinks = find(V1 < LowCorrlim);

linkscontrol = [V1(links) V2(links)];
nolinkscontrol = [V1(nolinks) V2(nolinks)];


        
        
        
        
        
        