
function ggmNet = GGMinfer(data,cutoff)

% Attention: The ggmNet vector as output of this function corresponds to
% the upper triangular part of the interaction matrix.

P = corr(data);
B = inv(P);
v = diag(B);
R = (-1*B)./(sqrt(v*v')); % GGM correlation values

% generating randomly permuted datasets for calculation of p-value
Nperms = 1000;
[Nrep,Nnode] = size(data);

permuted_data = zeros(size(data));
for k = 1:Nperms
    for j = 1:Nnode
        permuted_data(:,j) = data(randperm(Nrep),j);
    end
    PP = corr(permuted_data);
    BB = inv(PP);
    vv = diag(BB);
    RR(:,:,k) = (-1*BB)./(sqrt(vv*vv'));
end

absR = abs(R);
absRR = abs(RR);

I = triu(ones(size(R)),1);
Rupvec = absR(find(I));
RRupvec = zeros(length(Rupvec),Nperms);
for i = 1:Nperms
    RRi = absRR(:,:,i);
    RRupvec(:,i) = RRi(find(I));
end

for i = 1:length(Rupvec)
    pval(i,1) = length(find(Rupvec(i)<RRupvec(i,:)))/Nperms;
end

h = zeros(size(pval));
h(pval<cutoff) = 1;

ggmNet = h;





