
function noisyC = addnoise(C,m,s)
%
% This function takes in a matrix C (e.g, covariance matrix of data) and
% symmetrically multiply each element of that matrix with a random number 
% sampled from normal distribution with mean value m and standard deviation
% s.

r = m + s.*randn(size(C));

% Make the noisefactor symmetric
r = triu(r,1)+transpose(triu(r,1))+eye(size(r)).*r;

noisyC = r.*C;



